using System;
using System.Collections.Generic;
using System.Text;

namespace WordNetParser.Objects
{
	internal struct Index
	{
		private long mIdxOffset;		/* byte offset of entry in index file */
		private string mWord;			/* word string */
		private string mPartOfSpech;			/* part of speech */
		private int mSenseCount;		/* sense (collins) count */
		private int mOffsetCount;		/* number of offsets */
		private int mTaggedSensesCount;		/* number senses that are tagged */
		private List<long> mSynSetsOffsets;	/* offsets of synsets containing word */
		private int mPointersUsedCount;		/* number of pointers used */
		private List<int> mPointersUsed;		/* pointers used */

		/// <summary>
		/// byte offset of entry in index file
		/// </summary>
		public long IdxOffset { get { return mIdxOffset; } set { mIdxOffset = value; } }

		/// <summary>
		/// word string
		/// </summary>
		public string Word { get { return mWord; } set { mWord = value; } }

		/// <summary>
		/// part of speech
		/// </summary>
		public string PartOfSpech { get { return mPartOfSpech; } set { mPartOfSpech = value; } }

		/// <summary>
		/// sense (collins) count
		/// </summary>
		public int SenseCount { get { return mSenseCount; } set { mSenseCount = value; } }

		/// <summary>
		/// number of offsets
		/// </summary>
		public int OffsetCount { get { return mOffsetCount; } set { mOffsetCount = value; } }

		/// <summary>
		/// number senses that are tagged
		/// </summary>
		public int TaggedSensesCount { get { return mTaggedSensesCount; } set { mTaggedSensesCount = value; } }

		/// <summary>
		/// offsets of synsets containing word
		/// </summary>
		public List<long> SynSetsOffsets { get { return mSynSetsOffsets; } set { mSynSetsOffsets = value; } }

		/// <summary>
		/// number of pointers used
		/// </summary>
		public int PointersUsedCount { get { return mPointersUsedCount; } set { mPointersUsedCount = value; } }

		/// <summary>
		/// pointers used
		/// </summary>
		public List<int> PointersUsed { get { return mPointersUsed; } set { mPointersUsed = value; } }
	}
}
